# vim: set ts=4 sw=4 et:

Name:           highlight
Summary:        Universal Source Code to Formatted Text Converter
Version:        3.6
Release:        4.24
Group:          Development/Tools/Other
License:        GNU General Public License version 2 or later (GPLv2 or later)
URL:            http://www.andre-simon.de/
Source0:        http://www.andre-simon.de/zip/%{name}-%{version}.tar.bz2
Patch0:         highlight-makefile_suse.patch
Patch1:         highlight-optflags.patch
Patch2:         highlight-fix_desktop.patch
Patch3:         highlight-pass_optflags_to_qmake.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}.%{release}-root
BuildRequires:  boost-devel gcc-c++ libqt4-devel lua-devel
BuildRequires:  update-desktop-files

%description
A utility that converts sourcecode to HTML, XHTML, RTF, LaTeX, TeX, XML or ANSI
escape sequences with syntax highlighting.
It supports several programming and markup languages.
Language descriptions are configurable and support regular expressions.
The utility offers indentation and reformatting capabilities.
It is easily possible to create new language definitions and colour themes.

%package gui
Summary:        Universal Source Code to Formatted Text Converter
Group:          Development/Tools/Other
Requires:       %{name} = %{version}

%description gui
A utility that converts sourcecode to HTML, XHTML, RTF, LaTeX, TeX, XML or ANSI
escape sequences with syntax highlighting.
It supports several programming and markup languages.
Language descriptions are configurable and support regular expressions.
The utility offers indentation and reformatting capabilities.
It is easily possible to create new language definitions and colour themes.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2
%patch3

%build
%__sed -i -e "s|qmake-qt4|qmake|g" src/makefile
%__rm -f src/gui-qt/moc_*
%__make OPTFLAGS="%{optflags}" %{?_smp_flags}
%__make gui OPTFLAGS="%{optflags}" %{?_smp_flags}

%install
%makeinstall install-gui

%suse_update_desktop_file -r %{name} Utility TextEditor

L="$PWD/%{name}.lang"
LDIR="%{_datadir}/%{name}/gui_files/l10n"
echo -n >"$L"
pushd "%{buildroot}$LDIR"
/bin/ls -1 *.qm | while read qm; do
    [ -f "$qm" ] || continue
    l="${qm#*_}"
    l="${l%.qm}"
    echo "%lang($l) $LDIR/$qm" >>"$L"
done
popd

%clean
%{?buildroot:%__rm -rf "%{buildroot}"}

%files
%defattr(-,root,root,-)
%dir %{_docdir}/%{name}
%doc %{_docdir}/%{name}/*
%{_bindir}/%{name}
%dir %{_sysconfdir}/%{name}
%config %{_sysconfdir}/%{name}/filetypes.conf
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/langDefs
%{_datadir}/%{name}/langDefs/*.lang
%dir %{_datadir}/%{name}/plugins
%{_datadir}/%{name}/plugins/*.lua
%dir %{_datadir}/%{name}/themes
%{_datadir}/%{name}/themes/*.theme
%doc %{_mandir}/man1/%{name}.1%{ext_man}

%files gui -f "%{name}.lang"
%defattr(-,root,root,-)
%{_bindir}/%{name}-gui
%{_datadir}/applications/%{name}.desktop
%dir %{_datadir}/%{name}/gui_files
%dir %{_datadir}/%{name}/gui_files/ext
%{_datadir}/%{name}/gui_files/ext/fileopenfilter.conf
%dir %{_datadir}/%{name}/gui_files/l10n
%{_datadir}/pixmaps/%{name}.xpm

%changelog
* Wed Oct 12 2011 detlef@links2linux.de
- new upstream version <3.5>
  * added support for UPC (thanks to Viraj Sinha)
  * added support for N3, N-Triples, Turtle, SPARQL (suggested by  Heiko Jansen)
  * added Solarized color theme (thanks to Steve Huff)
  * fixed OCaml definition (thanks to Kakadu Hafanana)
  * fixed --force option (thanks to Stefan Bühler)
  * fixed camo colour theme
  * removed sienna and desertEx colour themes
  * CLI: fixed segfault with --print-style option
  * GUI: added "Dock floating panels" checkbox in the main menu
* Sat Jun  4 2011 pascal.bleser@opensuse.org
- use %%{optflags}
- update to 3.5:
  * updated astyle code to release 2.02
  * fixed --force option
* Sat Apr  2 2011 detlef@links2linux.de
- new upstream version <3.4>
  * added support for ABC, Algol, AS/400 CL, BCPL,  Limbo, Gambas, JavaFX,
    RPG, Transact-SQL, PL/Perl, PL/Tcl, PL/Python, Charmm
  * fixed web plugins (Serendipity, DokuWiki, Wordpress)
  * fixed BBCode closing tag order
  * GUI: Updated Czech translation (thanks to Pavel Fric)
* Thu Dec 30 2010 detlef@links2linux.de
- new upstream version <3.3>
  * updated astyle code to release 2.01
  * fixed overwriting of files with the same name in recursive batch mode
    (thanks to Ramanathan U.)
  * added DataDir class to SWIG interface (patch by David Bremner)
  * added Andes theme (thanks to Roger Sperberg)
  * enabled deprecated @highlight pass-through (suggested by David Bremner)
  * dropped oceandeep theme
  * updated documentation
* Sat Nov 13 2010 detlef@links2linux.de
- new upstream version <3.2>
  * added plug-in function AddKeyword (suggested by Michael Serrano)
  * language definitions are cached instead of being reloaded if input syntax
    changes
  * added keyword group ID parameter to the plug-in function OnStateChange
  * added plug-in script bash_functions.lua
  * added theme description in output style's comment
  * added enum and union keywords in c.lang (thanks to Thiago)
  * added dl linking flag in Makefile to fix Debian build error.
    (thanks to Michael Serrano)
  * added NDEBUG flag in makefile to disable asserts
* Wed Aug 25 2010 detlef@links2linux.de
- new upstream version <3.1>
* Fri Apr  2 2010 detlef@links2linux.de
- new upstream version <2.16>
  * updated astyle code to release 1.24
  * added indentation styles 1tbs and horstmann
  * added --no-trailing-nl switch (suggested by Adiel Mittmann)
  * added Modula2 definition (thanks to Benjamin Kowarsch)
  * added EBNF definition (thanks to Mate Ory)
  * added ABNF, AutoHotKey, BBCode and Clean language definitions
  * updated C++ definition to support C++0x syntax
  * added StartupNotify switch in desktop file (patch by Jochen Schmitt)
* Sat Feb 27 2010 detlef@links2linux.de
- new upstream version <2.15>
  * improved HTML nested language patterns (thanks to Simone)
  * improved Rexx and PL1 definitions (thabnks to Robert Prins)
  * added support for NXC and NBC
  * GUI: added copy and paste support (thanks to Torsten Flamminger)
  * GUI: fixed preview of UTF-8 input
* Mon Jan 25 2010 detlef@links2linux.de
- new upstream version <2.14>
  * fixed Rexx output (thanks to Marc Hessling)
  * added support for Go and Pure
  * added support for BNF (thanks to Julien Fontanet)
  * updated Logtalk definition (thanks to Paulo Moura)
  * updated THE theme  (thanks to Marc Hessling)
  * CLI: --quiet switch supresses "Unknown source file extension" error
    (suggested by Nathan Gray)
* Tue Oct 13 2009 detlef@links2linux.de
- new upstream version <2.13>
  * Fixed SVG output (thanks to Xico)
  * GUI: added new icon
* Fri Sep 11 2009 detlef@links2linux.de
- new upstream version <2.12>
  * fixed bug with $INCLUDE statement
  * fixed ctags file parsing
  * added nested language recognition within a source file (suggested by Pavel Striz)
  * added $NESTED statement to language definitions (pas, html, tex)
  * added support for F# (fs.lang)
  * added support for haXe (hx.lang)
  * improved various language definitions
  * revised documentation
  * LIB: added version to shared lib output name
  * CLI: added options --start-nested and --print-style
* Sat Aug  1 2009 detlef@links2linux.de
- new upstream version <2.11>
  * added BBCode output option (--bbcode, suggested by Qui Peccavit)
  * added new --delim-cr option to cope with MacOS 9 files
    (suggested by Steven Haddock)
  * added shared lib target (make lib-shared, suggested by Dario Teixeira)
  * list of installed languages (--list-langs) was enhanced to include mapped file
    extensions (suggested by Martin Kammerlander)
  * improved many colour themes using Agave (agave.sf.net)
* Wed Jul 22 2009 detlef@links2linux.de
- new upstream version <2.10>
  * fixed CR parsing bug on MacOS (thanks to Shiro Wilde)
  * fixed SWIG makefile (thanks to David Bremner)
  * license changed from GPLv2 to GPLv3 (incl. included libs)
  * updated Artistic Style lib to version 1.23
  * new indentation schemes: stroustrup, whitesmith, banner
  * removed indentSchemes and helpmsg directories
  * removed README_INDENT
  * replaced ide-devcpp theme by a new jedit theme
  * added support for Interactive Data Language (idlang, thanks to Roberto
    Mendoza)
  * added support for Rebol, Oz, Mercury, Zonnon, ATS (Applied Type System),
    CHILL, NetRexx, Inno Setup and INTERLIS
  * added pp, rjs, jnlp, groovy, gnad, es, sblc, ooc, gst, sq extensions
    to filetypes.conf
  * improved Prolog, Pike, Oberon, Nice, Java, Lisp, Lua, Haskell, C# and SML
    definitions
  * improved spec.lang for RPM (thanks to Luoyi Ly)
  * CLI: option --help-lang is deprecated
  * API: dropped setSpecialOptions(), renamed initializing methods to init*
- 2.9
  * added more customized boxes for the LaTeX --pretty-symbols switch
    (thanks to Romain Francois)
  * GUI: fixed makefile to pass costum paths to the Qt project makefile
    (thanks to Joerg Germeroth)
  * GUI: reduced window height (thanks to Fidel Barrera)
  * GUI: added Spanish translation (thanks to Fidel Barrera)
  * GUI: added drag and drop for input files
- 2.8
  * added --pretty-symbols option to improve LaTeX output quality of tilde and
    braces (thanks to Romain Francois)
  * omitted warning message if --syntax parameter is contained in the --skip list
    (thanks to Bob Smith)
  * included language descriptions in --list-langs output
  * dropped dependency of --replace-quotes and --fragment options
  * enhanced Python SWIG example (testmod.py)
  * added qmake language definition
  * fixed SWIG scripts (thanks to David Bremner)
  * fixed gcc 4.4 compilation (patch by Jochen Schmitt)
  * dropped core/html32generator.*
  * dropped src/gui (wxWidgets based interface)
  * GUI: rewrote the user interface using Qt
* Wed Jan 14 2009 detlef@links2linux.de
- new upstream version <2.7>
* Sat Nov  1 2008 detlef@links2linux.de
- new upstream version <2.6.14>
  * added --ctags-file option to add tooltips with meta information in HTML output
  * added options to improve compatibility with GNU source-highlight:
  - -doc, --no-doc, --tab, --css, --output-dir, --failsafe, --out-format,
  - -src-lang, --line-number, --line-number-ref
  * fixed ADA95, C#, Eiffel, Fortran, TCL, Bash definitions
  * added Vala language definition
  * added several file suffixes to filetypes.conf
  * fixed gcc 4.3 compilation issues (patch by Detlef Reichelt)
  * fixed race condition in makefile (patch by Jochen Schmitt)
  * added exit condition if input path matches output path (suggested by James Haefner)
  * GUI: added ctags file selection options (only wx2.9 version)
* Fri Oct  3 2008 detlef@links2linux.de
- new upstream version <2.6.13>
- add gcc43 patch
  * added --skip option to ignore unknown file types (suggested by Bob Smith)
  * added Haskell LHS language definition (suggested by Sebastian Roeder)
  * added regex description for Perl and Ruby definitions
  * improved Bison, Paradox, SML, Snobol, Verilog definitions
  * renamed snobol.lang to sno.lang
  * updated Artistic Style lib to version 1.22
  * replaced dirstream lib by a faster file globbing method (invoked with --batch-recursive)
  * support for USE_FN_MATCH compile flag was dropped
  * Makefile generates libhighlight.a (suggested by Adiel Mittmann)
  * updated SWIG makefile and documentation
* Thu Aug  7 2008 detlef@links2linux.de
- new upstream version <2.6.12>
  * added RTF character stylesheet option (suggested by Klaus Nordby)
  * fixed filetypes.conf path in RPM specfile (thanks to Nikita Borodikhin)
* Fri Jul 18 2008 detlef@links2linux.de
- new upstream version <2.6.11>
  * added SVG output option (--svg)^
  * reassigned -G short option from --class-name to --svg^
  * fixed various makefile issues (patches by Samuli Suominen)^
  * added highlight.desktop file (suggested by Samuli Suominen)^
  * GUI: added SVG and font selection options (only wx2.9 version)^
  * GUI: reduced window height by hiding format specific input controls^
  * updated highlight.spec to compile wx2.9 GUI^
* Sat May 10 2008 detlef@links2linux.de
- new upstream version <2.6.10>
* Fri Mar 28 2008 detlef@links2linux.de
- new upstream version <2.6.9>
* Fri Feb  1 2008 detlef@links2linux.de
- new upstream version <2.6.8>
* Tue Dec 11 2007 detlef@links2linux.de
- new upstream version <2.6.6>
* Fri Oct  5 2007 detlef@links2linux.de
- new upstream version <2.6.5>
* Sat Sep 15 2007 detlef@links2linux.de
- new upstream version <2.6.4>
* Fri Sep  7 2007 detlef@links2linux.de
- new upstream version <2.6.3>
* Mon Jul 23 2007 detlef@links2linux.de
- new upstream version <2.6.2>
* Thu Jun 28 2007 detlef@links2linux.de
- new upstream version <2.6.1>
* Thu May 10 2007 detlef@links2linux.de
- new upstream version
* Fri Nov 17 2006 detlef@links2linux.de
- new upstream version
* Sat Aug  5 2006 detlef@links2linux.de
- first build for packman
